//WebbotLib includes
#include "sys/axon2.h"
#include "servoPWM.h"
#include "a2d.h"
#include "rprintf.h"

//user includes
#include "hardware.h"


//the larger this number, the more likely your robot will drive straight
#define threshold 8

// In my initialising code - pass the list of servos to control
void appInitHardware(void)
	{
	//initialize UART ports
	uartInit(UART0, 38400);
	uartInit(UART1, 115200);//initialize USB
	uartInit(UART2, 115200);
	uartInit(UART3, 57600);

	//declare USB for output
	rprintfInit(&uart1SendByte);

	// Initialise the servo controller
	servoPWMInit(&bank1);
	// Give each servo a start value of 'stop'
	act_setSpeed(&left, 0);
	act_setSpeed(&right,0);
	}

TICK_COUNT appInitSoftware(TICK_COUNT loopStart){
return 0;
}


// This is the main loop
TICK_COUNT appControl(LOOP_COUNT loopCount, TICK_COUNT loopStart)
	{
	uint8_t lightLeft = a2dConvert8bit(sensorLeft);
	uint8_t lightRight = a2dConvert8bit(sensorRight);
	
	if(lightLeft > lightRight && (lightLeft - lightRight) > threshold)
		{
		// go left
		act_setSpeed(&left,DRIVE_SPEED_MIN);
		act_setSpeed(&right,DRIVE_SPEED_MAX);
		}
	
	else if(lightRight > lightLeft && (lightRight - lightLeft) > threshold)
		{
		// go right
		act_setSpeed(&left,DRIVE_SPEED_MAX);
		act_setSpeed(&right,DRIVE_SPEED_MIN);
		}
	
	else
		{
		// Go forwards
		act_setSpeed(&left,DRIVE_SPEED_MAX);
		act_setSpeed(&right,DRIVE_SPEED_MAX);
		}
	
	//print out detected difference
	rprintf("Going Right: %d\r\n", lightLeft - lightRight);

	return 20000; // wait for 20ms to stop crazy oscillations (long story)
	}
